////////////////////////////////////////////////////////////////////////////
// #02012603
//
// Copyright (C) 2002 Albert Vik
//
// E-mail: AlbertVik@operamail.com
//
// This source code is part of FLAC project. This source code is distributed 
// under the same policy as the FLAC project constitute except one addition:
// any modifications of this file and the source code in this file for 
// purposes other than for private use should be sanctioned by the author.
//
// The latest release of this source code is available on the  
// FLAC project home page: http://flac.sourceforge.net or
// directly from the author: AlbertVik@operamail.com
// 
////////////////////////////////////////////////////////////////////////////

#ifndef __CFLACDECODER_H__
#define __CFLACDECODER_H__

#include "FLAC_Apollo.h"

////////////////////////////////////////////////////////////////////////////
//
// Class CFLACDecoder - FLAC Decoding Functionality
//
////////////////////////////////////////////////////////////////////////////

class CFLACDecoder : public CFLACInfo, public CInputDecoder
{

public:

    CFLACDecoder(char *filename,int audioDataOffset);

    BOOL IsValid(){ return GetDecoder() && CFLACInfo::IsValid(); }

    FLAC__FileDecoder *GetDecoder(){ return m_decoder; }

    ~CFLACDecoder();

    ////////////////////////////////////////////
    // For calls from Apollo
    //
    int __cdecl GetNextAudioChunk(void **buffer);
    int __cdecl SetPosition(int newPosition);
  
    void __cdecl SetEqualizer(BOOL equalize){};
    void __cdecl AdjustEqualizer(int equalizerValues[16]){};

    void __cdecl Close() { delete this; }

private:

    // For calls from libFLAC global callback stubs
    void                           callback_error    ( FLAC__StreamDecoderErrorStatus status );
    void                           callback_metadata ( const FLAC__StreamMetaData *metadata );
    FLAC__StreamDecoderWriteStatus callback_write    ( const FLAC__Frame *frame, const FLAC__int32 *buffer[] );

    // Global libFLAC callback stubs for file decoder
    friend void                           flac_callback_error    (const FLAC__FileDecoder *decoder, FLAC__StreamDecoderErrorStatus status,                 void *client_data);
    friend void                           flac_callback_metadata (const FLAC__FileDecoder *decoder, const FLAC__StreamMetaData *metadata,                  void *client_data);
    friend FLAC__StreamDecoderWriteStatus flac_callback_write    (const FLAC__FileDecoder *decoder, const FLAC__Frame *frame, const FLAC__int32 *buffer[], void *client_data);

private:

    FLAC__FileDecoder *m_decoder;

    BOOL m_AbortFlag;

    FLAC__int8 *m_ProcessedBuffer;
    unsigned m_BufferSize;
    unsigned m_SamplesInBuffer;

};

#endif  //__CFLACDECODER_H__
