////////////////////////////////////////////////////////////////////////////
// #02012604
//
// Copyright (C) 2002 Albert Vik
//
// E-mail: AlbertVik@operamail.com
//
// This source code is part of FLAC project. This source code is distributed 
// under the same policy as the FLAC project constitute except one addition:
// any modifications of this file and the source code in this file for 
// purposes other than for private use should be sanctioned by the author.
//
// The latest release of this source code is available on the  
// FLAC project home page: http://flac.sourceforge.net or
// directly from the author: AlbertVik@operamail.com
// 
////////////////////////////////////////////////////////////////////////////

#ifndef __CFLACINFO_H__
#define __CFLACINFO_H__

#include "FLAC_Apollo.h"

//////////////////////////////////////////////////////////////
//
// lass CFLACInfo - FLAC File Detailed Information
//
//////////////////////////////////////////////////////////////

class CFLACInfo
{

public:

    CFLACInfo();
    CFLACInfo( char *filename);

    ~CFLACInfo();

    BOOL GetInfo( char *filename );

    BOOL IsMD5Signed();
    BOOL IsValid(){ return m_IsValid; };
    void Clear();

    ///////////////////////////////////////////////////////
    // Data Accessors
    //
    char *StrFileName()         { return m_StrFileName; }
    char *StrFileDate()         { return m_StrFileDate; }
    char *StrPlayingTime()      { return m_StrPlayingTime; }
    char *StrChannels()         { return m_StrChannels; }
    char *StrMD5()              { return m_StrMD5; }
    char *StrApproxMark()       { return m_StrApproxMark; }

    int      SampleWidth()      { return m_SampleWidth; }
    double   Compression()      { return m_Compression; }
    unsigned TotalSamples()     { return m_TotalSamples; }
    unsigned BitsPerSample()    { return m_BitsPerSample; }
    unsigned SampleRate()       { return m_SampleRate; }
    unsigned Channels()         { return m_Channels; }
    unsigned FileSize()         { return m_FileSize; }
    unsigned PlayingTime()      { return m_PlayingTime; }
    unsigned BitRatePCM()       { return m_BitRatePCM; }
    unsigned BitRateFLAC()      { return m_BitRateFLAC; }
    unsigned MinBlocksize()     { return m_MinBlocksize; }
    unsigned MaxBlocksize()     { return m_MaxBlocksize; }
    unsigned MinFramesize()     { return m_MinFramesize; }
    unsigned MaxFramesize()     { return m_MaxFramesize; }

    FLAC__byte  *MD5Sum()       { return m_MD5Sum; }

private:

    char *m_StrFileName;
    char *m_StrApproxMark;
    char  m_StrFileDate[32];
    char  m_StrPlayingTime[16];
    char  m_StrChannels[16];
    char  m_StrMD5[128];

    int      m_SampleWidth;
    double   m_Compression;
    unsigned m_TotalSamples;
    unsigned m_BitsPerSample;
    unsigned m_SampleRate;
    unsigned m_Channels;
    unsigned m_FileSize;
    unsigned m_PlayingTime;
    unsigned m_BitRatePCM;
    unsigned m_BitRateFLAC;
    unsigned m_MinBlocksize, m_MaxBlocksize;
    unsigned m_MinFramesize, m_MaxFramesize;

    FLAC__byte m_MD5Sum[16];

    BOOL m_IsValid;
 
};

#endif  //__CFLACINFO_H__
