////////////////////////////////////////////////////////////////////////////
// #02012602
//
// Copyright (C) 2002 Albert Vik
//
// E-mail: AlbertVik@operamail.com
//
// This source code is part of FLAC project. This source code is distributed 
// under the same policy as the FLAC project constitute except one addition:
// any modifications of this file and the source code in this file for 
// purposes other than for private use should be sanctioned by the author.
//
// The latest release of this source code is available on the  
// FLAC project home page: http://flac.sourceforge.net or
// directly from the author: AlbertVik@operamail.com
// 
////////////////////////////////////////////////////////////////////////////

#ifndef __CFLACPLUGIN_H__
#define __CFLACPLUGIN_H__

#include "FLAC_Apollo.h"

////////////////////////////////////////////////////////////////////////////
//
// Class CFLACPlugin - General Apollo Plug-ins functionality
//
////////////////////////////////////////////////////////////////////////////

class CFLACPlugin : public CInputPlugin
{

public:

    CFLACPlugin(HINSTANCE hDLLInstance,HWND hApolloWnd) : m_hDLLInstance(hDLLInstance), m_hApolloWnd(hApolloWnd) {}

    CInputDecoder *__cdecl Open(char *filename,int audioDataOffset);

    char *__cdecl GetExtensions();
    char *__cdecl GetDescription();
    BOOL  __cdecl IsSuitableFile(char *filename,int audioDataOffset);
    BOOL  __cdecl GetInfo(char *filename,int audioDataOffset,TrackInfo *trackInfo);
    void  __cdecl AdditionalInfo(char *filename,int audioDataOffset);

    void __cdecl Config();
    void __cdecl About();

    void __cdecl Close() { delete this; }

private:

    HINSTANCE m_hDLLInstance;
    HWND m_hApolloWnd;

};

#endif  //__CFLACPLUGIN_H__
