////////////////////////////////////////////////////////////////////////////
// #02012637
//
// The source code for ID3 v1 tag was originally written
// by Josh Coalson <jcoalson@users.sourceforge.net> and
// rewritten as class by Albert Vik <AlbertVik@operamail.com>
//
// The latest release of this source code is available on 
// FLAC project home page: http://flac.sourceforge.net or
// 
////////////////////////////////////////////////////////////////////////////

#include "FLAC_Apollo.h"

////////////////////////////////////////////////////////////////////////////
//
// Class CId3v1 - Id3 v1 tag information
//
////////////////////////////////////////////////////////////////////////////

CId3v1::CId3v1()
{
    Clear();

}  // CId3v1::CId3v1()



CId3v1::CId3v1( char * filename )
{
    Clear();

    GetTag(filename);

}  // CId3v1::CId3v1()



void CId3v1::Clear()
{
    *raw=0; *title=0; *artist=0; *album=0; *comment=0;
    year=0; track =0; genre=0;

    isValid = FALSE;

}  // CId3v1::Clear()



BOOL CId3v1::GetTag(char *filename)
{
    Clear();
    
    const char *temp;    // Set the title to the filename by default

    if(  temp = strrchr(filename, '/') ) temp++;
    else temp = filename;

    strcpy( title, temp );
    strcpy( artist,"No Artist" );
    strcpy( album, "No Album" );

    FILE *file = fopen(filename, "rb");
    if( !file )  return FALSE;

    if( fseek(file, -128, SEEK_END) == -1 ) 
    {
        fclose(file); 
        return FALSE;
    }

    if( fread( raw, 1, 128, file ) < 128 ) 
    {
        fclose(file);
        return FALSE;
    }

    fclose(file);

    if( strncmp((const char*)raw, "TAG", 3) ) return FALSE;
    else 
    {
	char year_str[5];

        memcpy( title,    raw+ 3, 30 );
        memcpy( artist,   raw+33, 30 );
        memcpy( album,    raw+63, 30 );
        memcpy( year_str, raw+93,  4 ); year_str[4] = '\0'; year = atoi(year_str);
        memcpy( comment,  raw+97, 30 );
        genre = (unsigned)(raw[127]);
        track = (unsigned)(raw[126]);
    }

    return isValid = TRUE;

}  // CId3v1::GetTag()

