////////////////////////////////////////////////////////////////////////////
// #02012607
//
// This source code for ID3 v1 tag was originally written
// by Josh Coalson <jcoalson@users.sourceforge.net> and
// wrapped to class by Albert Vik <AlbertVik@operamail.com>
//
// The latest release of this source code is available on 
// FLAC project home page: http://flac.sourceforge.net or
// 
////////////////////////////////////////////////////////////////////////////

#ifndef __CID3V1_H__
#define __CID3V1_H__

#include "FLAC_Apollo.h"

//////////////////////////////////////////////////////////////
//
// Class CId3v1 - Id3 v1 tag information
//
//////////////////////////////////////////////////////////////

class CId3v1 
{
public:
    CId3v1();
    CId3v1( char * filename );

    BOOL GetTag( char * filename );
    BOOL IsValid(){ return isValid; };
    void Clear();

    unsigned char raw[128];
    char title[31];
    char artist[31];
    char album[31];
    char comment[31];
    unsigned year;
    unsigned track; 
    unsigned genre;

private:

    BOOL isValid;

};

#endif  //__CID3V1_H__
